function [ ClassG, Feature ] = GlobalClassification( ClassQRS, ClassPQ, QRSCount )
    global Sig, global QRS
    Feature = zeros( 12, 1 );
    ClassG = zeros( QRSCount, 1 );
    
    ind = 1;
    for i = 1:QRSCount
        Ctrl = 1;
        PQ = ClassPQ( i );
        QRSc = ClassQRS( i );
        switch PQ
            case 1 %Noisy
                switch QRSc
                    case 1
                        ClassG(i) = 1; %Noisy
                    case 2
                        ClassG(i) = 2; %Other
                    case 3 
                        ClassG(i) = 3; %Normal
                end
            case 2 %Other
                switch QRSc
                    case 1
                        ClassG(i) = 1; %Noisy
                    case 2
                        ClassG(i) = 2; %Other
                    case 3
                        ClassG(i) = 2; %Other
                end
            case 3 %Normal
                switch QRSc
                    case 1
                        ClassG(i) = 1; %Noisy
                    case 2
                        ClassG(i) = 2; %Other
                    case 3
                        ClassG(i) = 3; %Normal
                end
            case 4 %FiS
                switch QRSc
                    case 1
                        ClassG(i) = 1; %Noisy
                    case 2
                        ClassG(i) = 4; %FiS
                    case 3
                        ClassG(i) = 4; %FiS
                end
        end
    end
   for ii = 1:4
        LogicInd = (ClassG == ii);
        PosInd = find( LogicInd == 1 ); 
        PosIndRelative = PosInd./Sig.length; %Relativn umstn EKG cyklu.


        %Vyhodnocen potu a umstn souvislch sek podle skupin
        if isempty( PosInd )
            GroupSize = 0;
            GroupCenter = 0;
            GroupMax = 0;
            LogicInd = 1;
        elseif length( PosInd ) == 1
            GroupSize = 1;
            GroupCenter = PosInd;
            GroupMax = 1;
            LogicInd = 1;
        else
            GroupInd = clusterdata(PosInd, 1);
            GroupMax = max( GroupInd );
            GroupSize = zeros( GroupMax, 1 );
            GroupCenter = zeros( GroupMax, 1 );
            for kk = 1:GroupMax
                GroupSize(kk) = sum( GroupInd == kk );% Poet prvk kad sekvence
                GroupCenter(kk) = mean( PosInd( GroupInd == kk ) );% Umstn centrlnho prvku v signlu
            end
        end

        %Parametrizace pro skupinu 14
        switch ii
            case 1 %Noisy
                Feature( Ctrl ) = max( GroupSize )./QRSCount; %Relativn dlka nejdelho spojitho seku
                Ctrl = Ctrl + 1;
                Feature( Ctrl ) = GroupMax./sum( LogicInd ); %Poet skupin;
                Ctrl = Ctrl + 1;
                Feature( Ctrl ) = sum( LogicInd )./QRSCount; %Relativn poet v signlu;
                Ctrl = Ctrl + 1;
            case 2 %Other
                Feature( Ctrl ) = sum( LogicInd ); %Absolutn poet abnormal
                Ctrl = Ctrl + 1;
                Feature( Ctrl ) = GroupMax./sum( LogicInd ); %Poet skupin;
                Ctrl = Ctrl + 1;
                Feature( Ctrl ) = sum( LogicInd )./QRSCount; %relativn poet abnormal
                Ctrl = Ctrl + 1;
            case 3 %Normal
                Feature( Ctrl ) = max( GroupSize )./QRSCount; %Relativn dlka nejdelho spojitho seku
                Ctrl = Ctrl + 1;
                Feature( Ctrl ) = GroupMax./sum( LogicInd ); %Poet skupin;
                Ctrl = Ctrl + 1;
                Feature( Ctrl ) = sum( LogicInd )./QRSCount; %Relativn poet v signlu;
                Ctrl = Ctrl + 1;
            case 4 %FiS
                Feature( Ctrl ) = sum( LogicInd )./QRSCount; %Relativn vskyt FiS
                Ctrl = Ctrl + 1;
                Feature( Ctrl ) = GroupMax./sum( LogicInd ); %Poet skupin;
                Ctrl = Ctrl + 1;
                Feature( Ctrl ) = max( GroupSize )./QRSCount; %Relativn dlka nejdelho spojitho seku
                Ctrl = Ctrl + 1;
        end
   end
    
    Aux = median( QRS.RR( :, 1 ) );
    Feature( Ctrl ) = PQFtNorm( Aux , 221, -150, 250, 'false' );
    Ctrl = Ctrl + 1;

    Aux = var( QRS.RR( :, 1 ) );
    Feature( Ctrl ) = PQFtNorm( Aux , 0, 0, 1.5e4, 'false' );
    Ctrl = Ctrl + 1;
end
%% 
function y = PQFtNorm( x, xMed, xThreshLow, xThreshHigh, LogTrans )
    
    y = x;
    if LogTrans == true
        y = log( abs( y ) + 1 );
    end

    y = y - xMed;
    
    y( y <= xThreshLow ) =  xThreshLow;
    y( y >= xThreshHigh ) =  xThreshHigh;   
    y = ( y - xThreshLow )/( xThreshHigh - xThreshLow );
    
end
