% clear; clc; close all;
function [Feature]=VUT_QRS(ecg)
global Options, global Sig, global QRS, global Setting
ecg=ecg*1000;
ecg=ecg';
% D = what('training2017'); 
load('SVMrbf_Init.mat')

Sig.fs = 300;
Options = struct( 'Method', 'ward',... %Clustering method
                  'Distance', 'euclidean',... %Clustering distance
                  'Cut_off', 0.2,... %Cluster cut off
                  'Standard', false,... %QRS segment z-score standardization
                  'Passband', [3, 5],...%Hz
                  'Window', 70,... %Time window  QRS ref. [ms]
                  'SignalTrim', 1000); %Orez poctu QRS z obou stran: 1 QRS nebo vsechny komplexy pod 1000 ms od kraje              
Setting = struct( 'IIRenvelopeFiltB', [0.0009 0.0028 0.0028 0.0009 ],... %koefienty IIR filtru pro vyhlazen oblky koeficient DWT (Butter 3. d, fmez = 10 Hz)
                  'IIRenvelopeFiltA', [1.0000 -2.5819 2.2467 -0.6573]);

          Scale.s0 = 0.001; %smallest scale
          Scale.ds = 0.006; %scale spacing
          Scale.nb = 5; %number of scales
          Scale.type = 'lin'; %Type of spacing
          wav.name = 'paul';
          wav.param = 2;
              
if Options.Window > Options.SignalTrim, error('Parameter Window in struct Options must be less than SignalTrim'), end
              

% Index = QRSClass.Index( QRSClass.BeatClass )';

% for i = 1:8528
    

%     A = load([D.path '\' D.mat{i}]); 
    Sig.data = ecg; 
    Sig.length = length( Sig.data );
%     Sig.Index = 1;

    
    %Odstraneni driftu pomoci vicestupnove medianove filtrace
    [ DataFilt, MovMedianSig ] = PyramidMedianFilt( Sig.data );
    Sig.data = DataFilt(:);


    %Filtrace a odhad SNRf  
    [SNRf, DataFilt] = SNR_W5_cor( Sig.data, Sig.fs, 0.09*Sig.fs, 1 );
    Sig.data = DataFilt(:);
    SNRf = SNRfInterp( SNRf );
    SNRf = transpose( SNRf );
    
    
    %Rozklad pomoc CWT
    CWTs = cwtft({Sig.data, 1/Sig.fs}, 'wavelet', wav, 'scales', Scale, 'padmode', 'asym' );
    CWTc = CWTs.cfs; CWTc = transpose( CWTc ); clear CWTs
    
    
    %Detekce QRS
    Locs1 = QRSdet_TKEO_2( Sig.fs, Sig.data', 2 );
    Locs2 = QRSdet_WAVE_5( Sig.fs, Sig.data', 2 );
    Locs3 = detQRS_ST_02 ( Sig.fs, Sig.data );
    QRS.R = group_QRS( {Locs1, Locs2, Locs3}, round(0.1 * Sig.fs), 3);
    QRS.R = round( QRS.R );
    QRS.R = QRS.R(:);
    
    
    %Naten globlnch pozic QRS
%     QRS.R = QRSg{i};
%     QRS.R = QRS.R(:);
    

    %Nastaven limit pro odstrann QRS na hranicch signlu
    AuxA.TrimLim = Options.SignalTrim*Sig.fs/1000; 
    AuxA.TrimLim = ceil( AuxA.TrimLim );
    AuxA.TrimL = length( QRS.R( QRS.R < AuxA.TrimLim ) );
    if AuxA.TrimL == 0, AuxA.TrimL = 1; end
    AuxA.TrimR = length( QRS.R( QRS.R > Sig.length - AuxA.TrimLim ) );
    if AuxA.TrimR == 0, AuxA.TrimR = 1; end

    
    %RR-1 a RR+1
    QRS.RR = diff( QRS.R( 1:end-1) );
    QRS.RR= [QRS.RR diff( QRS.R( 2:end) ) ];
    QRS.RR = QRS.RR( AuxA.TrimL: end-AuxA.TrimR + 1, :);

    
    %Uprava vektoru s pozicemi QRS
    QRS.R = QRS.R( AuxA.TrimL + 1:end-AuxA.TrimR );
    QRS.Count = length( QRS.R );
    
    
    %Grupovn QRS komplex
    [ Tree,  DistMat ] = QRS_corr;

    
    % Grupovn RR interval
    TreeRR = linkage( QRS.RR( :,1 ), 'average', 'euclidean' );
    QRS.RRGroupIndex = cluster( TreeRR, 'Cutoff', 60, 'criterion', 'distance' );

    
    %Rozmen QRS
    T_end_estim_v3( CWTc( :, 1 ) );
       
    
    %Klasifikace QRS local
    [ Feature, ~ ] = BeatClassGroup( SNRf, CWTc, MovMedianSig, DistMat, Tree, Options.Window);
    ClassQRSInit = predict(SVqrsInit, Feature);
    
    
    %Klasifikace PQ local
    [Feature, ~] = PQClass( SNRf, MovMedianSig, ClassQRSInit );
    ClassPQInit = predict(SVpqInit, Feature);
    
    
    %Klasifikace PQRS local
    [ClassG, Feature] = GlobalClassification( ClassQRSInit, ClassPQInit, QRS.Count );
    Feature = Feature';
    
   
    

% end


    