function [ Feature ] = GlobalClassificationv3( ClassQRS, ClassPQ, QRSCount )
    global Sig
    
    Feature = [];
    PQRS = [1 1; 1 2; 1 3; 2 1; 2 2; 2 3; 3 1; 3 2; 3 3; 4 1; 4 2; 4 3;];
    Ctrl = 1;
    
    ClassG = [];
    for i = 1:QRSCount
        PQ = ClassPQ( i );
        QRSc = ClassQRS( i );
        switch PQ
            case 1 %Noisy
                switch QRSc
                    case 1
                        ClassG(i,1) = 1; %Noisy
                    case 2
                        ClassG(i,1) = 2; %Other
                    case 3 
                        ClassG(i,1) = 3; %Normal
                end
            case 2 %Other
                switch QRSc
                    case 1
                        ClassG(i,1) = 1; %Noisy
                    case 2
                        ClassG(i,1) = 2; %Other
                    case 3
                        ClassG(i,1) = 2; %Other
                end
            case 3 %Normal
                switch QRSc
                    case 1
                        ClassG(i,1) = 1; %Noisy
                    case 2
                        ClassG(i,1) = 2; %Other
                    case 3
                        ClassG(i,1) = 3; %Normal
                end
            case 4 %FiS
                switch QRSc
                    case 1
                        ClassG(i,1) = 1; %Noisy
                    case 2
                        ClassG(i,1) = 4; %FiS
                    case 3
                        ClassG(i,1) = 4; %FiS
                end
        end
    end
    
    
    for ii = 1:11
        switch ii
           case {1 2 3 4}
               LogicInd = (ClassPQ == ii);

           case {5 6 7}
               LogicInd = (ClassQRS == (ii - 4));

           case {8 9 10 11}
               LogicInd = (ClassG == ii - 7);

        end
        Locs = find( LogicInd == 1 );

        %Vyhodnocen potu a umstn souvislch sek podle skupin
        if isempty( Locs )
            GroupSize = 0;
            GroupCenter = 0;
            GroupMax = 0;
            LogicInd = 0;
        elseif length( Locs ) == 1
            GroupSize = 1;
            GroupCenter = Locs;
            GroupMax = 1;
            LogicInd = 1;
        else
            GroupInd = clusterdata(Locs, 1);
            GroupMax = max( GroupInd );
            GroupSize = zeros( GroupMax, 1 );
            GroupCenter = zeros( GroupMax, 1 );
            for kk = 1:GroupMax
                GroupSize(kk) = sum( GroupInd == kk );% Poet prvk kad sekvence
                GroupCenter(kk) = mean( Locs( GroupInd == kk ) );% Umstn centrlnho prvku v signlu
            end
            GroupCenter = GroupCenter./Sig.length;
        end

        Feature( Ctrl:Ctrl+5) = ParamEstim( LogicInd, GroupSize, Locs );
        Ctrl = Ctrl + 6;
    end
    
    %Poet QRS
    Feature( Ctrl ) = QRSCount;
    Ctrl = Ctrl + 1;
   
    %Dlka signlu
    Feature( Ctrl ) = Sig.length;
    Ctrl = Ctrl + 1;
    
    %Dlka signlu
    Aux = diff( ClassQRS );
    Feature( Ctrl ) = median( abs( Aux ) );
    Ctrl = Ctrl + 1;
    
    %Dlka signlu
    Feature( Ctrl ) = sum( Aux.^2 );
    Ctrl = Ctrl + 1;
    
    %Dlka signlu
    Aux = diff( ClassPQ );
    Feature( Ctrl ) = median( abs( Aux ) );
    Ctrl = Ctrl + 1;
    
    %Dlka signlu
    Feature( Ctrl ) = sum( Aux.^2 );
    Ctrl = Ctrl + 1;
end
%% 
function Feature = ParamEstim( LogicInd, GroupSize, Locs )
    %Relativn poet v signlu;
    Feature( 1 ) = sum( LogicInd ); 
    
    %Relativn dlka nejdelho spojitho seku
    Feature( 2 ) = max( GroupSize ); 
    
    %Poet segment o 1 EKG cyklu;
    Feature( 3 ) = sum( GroupSize == 1 );

    %Prmrn dlka spojitch segment
    Feature( 4 ) = mean( GroupSize ); 

    %Rozptyl dlky spojitch segment
    Feature( 5 ) = std( GroupSize ); 

    %Rozptyl pozic jednotlivch sykl v datech
    if isempty( Locs )
        Feature( 6 ) = 0;
    else
        Feature( 6 ) = median( abs( Locs - median( Locs )));
    end 
end
