function [Feature, FeatureName] = PQClass( SNRf, MovMedianSig, ClassQRS )
    global QRS
    global Sig

    
    Feature = [];
    FeatureName = {};
    
    %Nastaven dlky okna
    Win{1} = ( 200*Sig.fs )/1000;
    Win{1} = ceil( Win{1} );
    Win{1} = -Win{1}:0;
    
    %Moving median PCA transform coeff
    TW.MovMedianPCA = [-0.569066228564342; -0.541965574442593; -0.618414863668514];
    %Delta RR hist borders
    TW.DeltaRRLim = [0 20 40 60 80 100 200 inf]./3;
    %% 
    
    %Zmna RR
    RRPrev = QRS.RR(: , 1 );
    RRPost = QRS.RR(: , 2 );
    DeltaRRPrev = diff( [ RRPrev(1,1); RRPrev(:,1) ] );
    DeltaRRPost = RRPost - RRPrev;
    
    ecgOrig = Sig.data;
    
    

    %% 
    for i = 1:QRS.Count
        
        Ctrl = 1;
        
        if isnan( QRS.Onset(i) )
            Feature( i, 1:17 ) = 0;
            continue
        end
        
        Range = QRS.Onset(i) + Win{1};
       
        
        %% SNRf param
        %1
        Feature( i, Ctrl ) = min( SNRf( Range ) );
        FeatureName{ i } = 'SNRf';
        Ctrl = Ctrl + 1;
        
        
        %% MovMedian
        %2
        Aux = zeros( 1, 3 );
        for ii = 1:3
            Aux(ii) = max( abs( MovMedianSig( ii, Range ) ) );
        end
        Aux = log( Aux + 0.0001 );
        Aux = Aux*TW.MovMedianPCA;
        Feature( i, Ctrl ) = Aux;
%         Feature( i, Ctrl ) = PQFtNorm( Aux , 0, -10, 1, 'false' );
        FeatureName{ i } = 'MovMedianPCA';
        Ctrl = Ctrl + 1;
        
        
        %% Local and global RR variability
        %3
        Aux = ClassQRS(i)./3;
        Feature( i, Ctrl ) = Aux;
        Ctrl = Ctrl + 1;
        
        
        %% Pattern similarity measure
        %4
        Aux = median( QRS.RR( :, 1 ) );
        Feature( i, Ctrl ) = Aux;
%         Feature( i, Ctrl ) = PQFtNorm( Aux , 221, -150, 250, 'false' );
        Ctrl = Ctrl + 1;
        
        %5
        Aux = var( QRS.RR( :, 1 ) );
        Feature( i, Ctrl ) = Aux;
%         Feature( i, Ctrl ) = PQFtNorm( Aux , 0, 0, 1.5e4, 'false' );
        Ctrl = Ctrl + 1;

        %6
        Aux = RRPrev( i );
        Feature( i, Ctrl ) = Aux;
%         Feature( i, Ctrl ) = PQFtNorm( Aux , 200, -150, 300, 'false' );
        Ctrl = Ctrl + 1;
        
        %7?????
        Aux = RRPost( i );
        Feature( i, Ctrl ) = Aux;
%         Feature( i, Ctrl ) = PQFtNorm( Aux , 220, -150, 350, 'false' );
        Ctrl = Ctrl + 1;
        
        Aux = DeltaRRPrev( i );
        Feature( i, Ctrl ) = Aux;
%         Feature( i, Ctrl ) = PQFtNorm( Aux , 0, -320, 320, 'false' );
        Ctrl = Ctrl + 1;
        
        %9
        Aux = DeltaRRPost( i );
        Feature( i, Ctrl ) = Aux;
%         Feature( i, Ctrl ) = PQFtNorm( Aux , 0, -320, 320, 'false' );
        Ctrl = Ctrl + 1;

        Indexes = 1:QRS.Count; 
        Indexes( Indexes == i ) = [];
        for ii = 1:4
            switch ii
                case 1
                    Aux = RRPrev( i ) - RRPrev( Indexes );
                case 2
                    Aux = RRPost( i ) - RRPost( Indexes );
                case 3
                    Aux = DeltaRRPrev( i ) - DeltaRRPrev( Indexes );
                case 4
                    Aux = DeltaRRPost( i ) - DeltaRRPost( Indexes );
            end
        
%             Aux2 = min( abs( Aux ) );%10 %18 %26 %34
%             Feature( i, Ctrl ) = PQFtNorm( Aux2 , 0, 0, 5.5, 'true' );
%             Ctrl = Ctrl + 1;
            
            Aux2 = max( abs( Aux ) );%11? %19? %27 %35  9,13,17,21
            Feature( i, Ctrl ) = Aux2;
%             Feature( i, Ctrl ) = PQFtNorm( Aux2 , 0, 1, 7, 'true' );
            Ctrl = Ctrl + 1;

            Aux2 = median( Aux );%12 %20 %28 %36
            Feature( i, Ctrl ) = Aux2;
%             Feature( i, Ctrl ) = PQFtNorm( Aux2 , 0, -360, 360, 'false' );
            Ctrl = Ctrl + 1;

            Aux2 = var( Aux );%13 %21 %29 %37 OK    10,14,18,22
            Feature( i, Ctrl ) = Aux2;
%             Feature( i, Ctrl ) = PQFtNorm( Aux2 , 0, 0, 12, 'true' );
            Ctrl = Ctrl + 1;

            Aux2 = skewness( Aux );%14 %22 %30 %38 OK   11,15,19,23
            if isnan( Aux2 ), Aux2 = 0; end
            Feature( i, Ctrl ) = Aux2;
%             Feature( i, Ctrl ) = PQFtNorm( Aux2 , 0, -6, 6, 'false' );
            Ctrl = Ctrl + 1;

            Aux2 = kurtosis( Aux );%15 %23 %31 %39 OK   12,16,20,24
            if isnan( Aux2 ), Aux2 = 0; end
            Feature( i, Ctrl ) = Aux2;
%             Feature( i, Ctrl ) = PQFtNorm( Aux2 , 0, 0, 4, 'true' );
            Ctrl = Ctrl + 1;

            Aux2 = moment( Aux, 5 );%16 %24 %32 %40 OK 13, 18,23,28
            Aux2 = abs( Aux2 );
            Feature( i, Ctrl ) = Aux2;
%             Feature( i, Ctrl ) = PQFtNorm( Aux2 , 0, 0, 30, 'true' );
            Ctrl = Ctrl + 1;
            
%             switch ii
%              case {1,2} 
%                  Feature( i, Ctrl ) = PQFtNorm( Aux2 , 0, -1.5e10, 1e10, 'false' );
%                  Ctrl = Ctrl + 1;
%              case {3,4}
%                  Feature( i, Ctrl ) = PQFtNorm( Aux2 , 0, -1e11, 1e11, 'false' );
%                  Ctrl = Ctrl + 1;
%             end
            
%             Aux2 = moment( Aux, 6 );%17 %25 %33 %41 OK
        end
        
    end

    QRSGroupMax = max( QRS.GroupIndex );
    a = [6.5    4   6   4   0   0   1   1.5     1.5 1   0   3.5     4 0 0];
    b = [12     11  13  11  5   6   6   7       7   7   7   8.5     9 30 30];
    
    for i = 1 : QRSGroupMax      
        Ctrl2 = Ctrl;
        QRSIndexes = find( QRS.GroupIndex == i );
        QRSGroupCount = length( QRSIndexes ); %Poet QRS ve skupine
        
        Win3 = -180:-1; %-62
        WinLen = length( Win3 );
        
        Aux1 = zeros( WinLen , QRSGroupCount ); %Pomocna promenna

        %Segmentace DWT signlu s QRS komplexy podle zaazen do skupiny kk
        for ii = 1:QRSGroupCount
            RWaveLoc = QRS.Onset( QRSIndexes( ii ) );
            if isnan( RWaveLoc )
                continue
            end
            Range = RWaveLoc + Win3;
            Aux1( :, ii ) = ecgOrig( Range );

        end
        medOrig = median( Aux1, 2 );    
        medOrig = detrend( medOrig );
        medOrig = medOrig - median( medOrig );
        %25
        Aux = abs( fft ( medOrig(120:end), 300 ) );
        Aux = sum( Aux(3:10).^2 );
        Feature( QRSIndexes, Ctrl2 ) = Aux;
%         Feature( QRSIndexes, Ctrl2 ) = PQFtNorm( Aux , 0, 11, 24, 'true' );
        Ctrl2 = Ctrl2 + 1;       
       
        for ii = 1:15 %27-38  %26-38
            Aux = paramPQGroup( ii, medOrig );
            Feature( QRSIndexes, Ctrl2 ) = Aux;
%             Feature( QRSIndexes, Ctrl2 ) = PQFtNorm( Aux , 0, a(ii), b(ii), 'true' );
            Ctrl2 = Ctrl2 + 1;
        end
    end
        
end

function y = PQFtNorm( x, xMed, xThreshLow, xThreshHigh, LogTrans )
    
    y = x;
    if LogTrans == true
        y = log( abs( y ) + 1 );
    end

    y = y - xMed;
    
    y( y <= xThreshLow ) =  xThreshLow;
    y( y >= xThreshHigh ) =  xThreshHigh;   
    y = ( y - xThreshLow )/( xThreshHigh - xThreshLow );
    
end