function [K1Az4]=Main(ecg,QRSg)
Sig.fs = 300;

Options = struct( 'Method', 'ward',... %Clustering method
                  'Distance', 'euclidean',... %Clustering distance
                  'Cut_off', 0.25,... %Cluster cut off
                  'Standard', false,... %QRS segment z-score standardization
                  'Passband', [1, 20],...%Hz
                  'Window', 50); %Time window  QRS ref. [ms]

IIR_high = designfilt('highpassiir', ...
        'FilterOrder',2, ...            
        'PassbandFrequency', Options.Passband(1), ...
        'PassbandRipple',0.05, ...
        'SampleRate', Sig.fs );


Sig.data = ecg; %Surov EKG data 
Sig.length = length(Sig.data);
QRS.global = QRSg; QRS.global = QRS.global(:); QRS.count = length( QRS.global );    
Sig.data = Sig.data(:); Sig.length = length(Sig.data);
Sig.data = filtfilt( IIR_high, Sig.data );

%Parametry pro hodnocen umu
[Param1, Param2, Group] = QRS_corr(Sig, QRS, Options); %Param1 - 1. dek matice Noisy_param.mat; Param 2 - 2. dek te matice

%Parametry pro hodnocen irokch komplex
[T1m, T2m] = xBBBmatch( Group.QRS_optim, Sig.data );  %T1m - 1. xBBB_tpl_match.mat T2m - 2. xBBB_tpl_match.mat
K1Az4=[Param1,Param2,T1m,T2m];