function [QRSg, inVar,  inVar1, inVarAM, inVar1AM, inVar2AM, inVar3AM] = det_LML_qrsVAR(fs,ecg)
    
    d = size(ecg);
    if d(1) > d(2); 
        ecg = ecg'; 
    end

	QRS1 = detQRS_ST_vut_01(fs,ecg);
	QRS2 = QRSdet_WAVE_5   (fs,ecg,2);
	QRS3 = DET_QRS_FULL_V01(ecg,fs);
        
	QRSloc = {QRS1, QRS2, QRS3}; tol = round(0.1 * fs);
	[QRSg, pom] = group_QRS(QRSloc, tol, length(QRSloc)); 
    
    % -- STD ----

    for i = 1 : length(pom)
        if (mean(pom{1,i})+tol)<=length(ecg)
            if length(pom{1,i}) == 2
                pom{2,i} = std([pom{1,i} mean(pom{1,i})+tol]);
                pom{3,i} = std(ecg(round([pom{1,i} mean(pom{1,i})+tol])));
                pom{4,i} = std(ecg(round([pom{1,i}])));
            else
                pom{2,i} = std(pom{1,i});
                pom{3,i} = std(ecg(pom{1,i}));
                pom{4,i} = pom{3,i};
            end
        end
    end
    inVar = mean([pom{2,:}]);
    inVar1 = median([pom{2,:}]);
    inVarAM = mean([pom{3,:}]);
    inVar1AM = median([pom{3,:}]);
    inVar2AM = median([pom{4,:}]);
    inVar3AM = mean([pom{4,:}]);   
    
    % -- Zobrazen --------------------------------------------------------
    if 0
        figure(1)
        M = length(ecg); t = linspace(0,M/fs,M);
        plot(t,ecg,'k'); hold on
        plot(t(QRS1),ecg(QRS1),'bo','markersize',10)
        plot(t(QRS2),ecg(QRS2),'bo','markersize',15)
        plot(t(QRS3),ecg(QRS3),'bo','markersize',20)
        plot(t(QRSg),ecg(QRSg),'rx','markersize',10)
        hold off
        figure(2)
        m = diff(sort(cell2mat(pom(1,:))));
        hist(m,60)
    end
    % ---------------------------------------------------------------------
end

% Lukas
function [QRS] = detQRS_ST_vut_01( fs, x, ~ )

% == Parameters ===========================================================
% Feature
fmez = [5 20];          % [Hz] spectrogram
% Standard phase
trhM = 0.375;          	% [%] threshold is XX% of mean of found last A peaks
trhM_LF = trhM;
A = 4;                	% [-] how many last peaks used for determining of threshold 
% Multiple detection
REF = 0.29;           	% [s] refractory period
% Search-back detection
RRmed = 9;           	% [-] how manny RR in flowing median
RR_M = 1.0;            	% [-] how many times could be actual RR longer than median RR 
lambda = 0.02;        	% [-] slope of the exponencial function
thrMIN = 0.09;         	% [%] minimal threshold is XX% of mean of found last B peaks
B = 3;                	% [-] how many last peaks used for determining of minimal threshold
% Other rules
RR_MM = 10;           	% [-] how many times is possible to be actual RR longer than median RR
learning_time = 2*fs; 	% [s] learning time

% Simulated annealing
% fmez = [6 24]; trhM = 0.35; A = 4; REF = 0.29; RRmed = 7; RR_M = 1.1; lambda = 0.025; thrMIN = 0.1; B = 4;
% =========================================================================
% -- Feature --------------------------------------------------------------
f_od = fmez(1);          % Hz
f_do = fmez(2);          % Hz
% step_t = 1;              % vz
step_f = 1;              % Hz

% load timer
% cas = tic;
[fea_ST] = feature_ST( x, fs, f_od, f_do, step_f );
% cas = toc(cas);
% time = [time cas];
% save('timer', 'time');


% -- Decision rulez -------------------------------------------------------
N = length(x);
REF = floor(REF*fs);

% QRS = decision_rule_02(fea_ST, fs, REF, trhM, pmax, N);
% QRS = decision_rule_01_st(fea_ST, trhM, REF, RRmed, RR_M, thrMIN, lambda, RR_MM, learning_time, N);

QRS = decision_rule_02_st(fea_ST, trhM, trhM_LF, REF, RRmed, RR_M, thrMIN, lambda, RR_MM, learning_time, N, A, B);

% plot(fea_ST); hold on; plot(QRS,fea_ST(QRS),'or');

% Supress warning
% [msg id] = lastwarn;
% warning('off',id)
end
function [fea_ST] = feature_ST( x, fs, f_od, f_do, step_f )
 
% -- Pre-Calculation ------------------------------------------------------

    N = length(x);
    t = 0:1/fs:(N-1)/fs;
    f = round((f_od : step_f : f_do)*(N/fs));
    F = length(f);
    
    gauss = cell(1,F);
    for i = 1 : F
        gauss{i} = g_window(N,f(i));
    end
% -----

    [ST] = S_tr_Fr_Pre(x, N, t, f, F, gauss);
%     [ST,~,~] = S_tr(x,fs,f_od,f_do,step_t,step_f);
 
    ESS = abs(ST).^2;
  	fea_ST = abs( sum( ESS .* log10(ESS) ) );

end
function [ST] = S_tr_Fr_Pre(x, N, t, f, F, gauss)

    if size(x,1) < size(x,2); x = x'; end

    % -- S-transform ----------------------------------------------------------
    
    vector_fft = fft(x);
    vector_fft = [vector_fft,vector_fft];

    ST = zeros(length(f),length(t));
    if f(1) == 0
        ST(1,:) = mean(x);
    else
        ST(1,:) = ifft(vector_fft(f(1)+1:f(1)+N) .* gauss{1});
    end

    for i = 2 : F
        ST(i,:) = ifft(vector_fft(f(i)+1:f(i)+N) .* gauss{i});
    end
    % -------------------------------------------------------------------------
end
function gauss = g_window(length,freq)

% Function to compute the Gaussion window for
% function Stransform. g_window is used by function
% Stransform. Programmed by Eric Tittley
%
%-----Inputs Needed--------------------------
%
%length-the length of the Gaussian window
%
%freq-the frequency at which to evaluate
%  the window.
%factor- the window-width factor
%
%-----Outputs Returned--------------------------
%
%gauss-The Gaussian window
%
factor = 1;

vector(1,:) = 0:length-1;
vector(2,:) = -length:-1;
vector = vector.^2;   
vector = vector*(-factor*2*pi^2/freq^2);
% Compute the Gaussion window
gauss = sum(exp(vector));
end
function QRS = decision_rule_02_st(fea_ST, trhM, trhM_LF, REF, RRmed, RR_M, thrMIN, lambda, RR_MM, learning_time, N, A, B)

feature = NaN(1,floor(N));
thr = feature;
QRS = []; y = [];

LF = 0;overTRH = 0; 
i = 0; thrDini = 0;
while i < N
    
    i = i + 1;
    feature(i) = fea_ST(i);
    
    if i > learning_time && LF == 0
        LF = 1;
    end

    if LF == 1  % learning period
        
        y = []; pom = feature(1:i); z = 1; k = 0;
        while isempty(y)
            [M, I] = max(pom);
            if I ~= z && I ~= i - k
            	thrLF = trhM_LF * M;
                [y, QRS] = findpeaks(pom,'MinPeakHeight',thrLF,'MinPeakDistance',REF);

                if numel(y) < 2
                    LF = 0; learning_time = learning_time * 1.1;  trhM_LF = trhM_LF * 0.9;
                    break
                else
                 	thr(1:i) = thrLF;
                    thr(i+1) = trhM * y(end);
                    MIN = thrMIN * y(end);
                    MAX = thr(i+1); 
                    RR_med  = median(diff(QRS));
                    last = QRS(end); 
                    LF = 2;
                end
            else
                if I == z
                    pom(z) = 0;
                    z = z+1;
                else
                    k = k+1;
                    pom(i - k + 1) = 0;
                end
            end
        end

    elseif LF == 2  % usual period
        
        thr(i+1) = thr(i);
        if feature(i) < thr(i)
            if overTRH == 1
                overTRH = 0; 
                [M, I] = max(feature(i_up : i));
                if I ~= 1
                    y(end+1) = M; 
                    QRS(end+1) = i_up + I - 1;
                    if (QRS(end) - last) < REF   % R-R les than REF
                        if y(end) > y(end-1)
                            y(end-1) = []; 
                            QRS(end-1) = [];
                        else
                            y(end) = []; 
                            QRS(end) = [];
                        end
                    end
                    y_pom = min([RRmed length(QRS)-1]);              	% V?po?et medi?nu RR z posledn?ch y_pom hodnot
                    RR_med = median(diff(QRS(end-y_pom:end)));      	% V?po?et medi?nu RR z posledn?ch y_pom hodnot
                    last = QRS(end);
    %                 thr(i+1) = trhM * y(end);
                    y_pom = min([A length(QRS)])-1;
                    thr(i+1) = trhM * mean(y(end-y_pom:end));
                    thrDini = 0;
                end
            else
                if (i - last) > REF
                    if (i - last) > RR_M*RR_med       % R-R more than 1.66*RR_med
                        if (i - last) > RR_MM*RR_med  % R-R more than 8.0*RR_med
%                             T = 0.99*max(feature(last+REF+1 : i)); 
%                             i = last+REF; 
%                             thr(i+1) = T; 
%                             thrDini = 0;
                            i = last + floor(RR_M*RR_med);
                            thrDini = 1;
                            MIN = MIN*0.5;
                        else
                            if thrDini == 0
                                MAX = thr(i); 
                                y_pom = min([B length(QRS)])-1;
                                MIN = min([thrMIN*mean(y(end-y_pom:end)) MAX]); 
%                                 MIN = min([thrMIN * y(end) MAX]); 
                            end
                            thrDini = thrDini + 1;
                            thr(i+1) = MIN + (MAX-MIN)*exp(-lambda*thrDini);  
                            searchBack = feature(last+REF+1 : i);

                            searchBack(searchBack<thr(i)) = 0;

                            if sum(searchBack) ~= 0
                                [M, I] = max(searchBack);
                                if I ~= 1
                                    y(end+1) = M; 
                                    QRS(end+1) = last+REF+1 + I - 1;
                                    y_pom = min([RRmed length(QRS)-1]);             	% V?po?et medi?nu RR z posledn?ch y_pom hodnot
                                    RR_med = median(diff(QRS(end-y_pom:end)));       	% V?po?et medi?nu RR z posledn?ch y_pom hodnot
                                    last = QRS(end); 
                                    y_pom = min([A length(QRS)])-1;
                                    thr(i+1) = trhM * mean(y(end-y_pom:end));
    %                                 thr(i+1) = trhM * y(end);
                                    thrDini = 0;
                                end
                            end
                        end              
                    end
                end
            end
        else    %feature(i) > thr(i)
            if overTRH == 0
                overTRH = 1;
                i_up = i;
            elseif (i - i_up) > 0.5*RR_med%RR_M*RR_med
                [M, I] = max(feature(i_up:i));
                if I ~= 1
                    y(end+1) = M; 
                    QRS(end+1) = i_up + I-1;
                    if (QRS(end) - last) < REF   % R-R les than REF
                        if y(end) > y(end-1)
                            y(end-1) = []; 
                            QRS(end-1) = [];
                        else
                            y(end) = []; 
                            QRS(end) = [];
                        end
                    end
                    y_pom = min([RRmed length(QRS)-1]);            	% V?po?et medi?nu RR z posledn?ch y_pom hodnot
                    RR_med = median(diff(QRS(end-y_pom:end)));        % V?po?et medi?nu RR z posledn?ch y_pom hodnot
                    last = QRS(end);
                    y_pom = min([A length(QRS)])-1;
                    thr(i+1) = trhM * mean(y(end-y_pom:end));
%                     thr(i+1) = trhM * y(end);
                end
                i_up = i;
            end
        end
    end
end

if overTRH == 1
    [M, I] = max(feature(i_up:i));
	if I ~= 1 && I < i-i_up+1-4
        y(end+1) = M; 
        QRS(end+1) = i_up + I-1;
        if (QRS(end) - last) < REF   % R-R les than REF
            if y(end) > y(end-1)
            	y(end-1) = []; 
              	QRS(end-1) = [];
            else
             	y(end) = []; 
              	QRS(end) = [];
            end
        end
	end
end

% figure(3);plot(feature,'b');hold on; plot(thr,'r'); plot(QRS,y,'ok'); hold off; %xlim([i-1000 i]);
% figure;plot(feature,'b');hold on;plot(thr,'r');plot(QRS,y,'ok'); xlim([i-1000 i+200]);

end

% Martin
function QRS = QRSdet_WAVE_5(fvz,vstup_sig,typ)
%------ NAPOVEDA ----------------------------------------------------------

% vstupni parametry
% fvz : pouzita vzorkovaci frekvence v Hz
% vstup_sig : vstupni signal ve formatu *.mat, radkovy vektor
% typ : 1, 2 nebo 3 (1 = ICRC, 2 = MIT, 0 = ICRC-MIT)

% vystupni parametry
% QRS : pozice QRS komplexu v zadanem svodu

%------ NASTAVENI PARAMETRU -----------------------------------------------

% parametry programu

%         k(1)  % psmo
%         k(2)  % nsobek prahu	
%         k(3)  % maximalni povolena vzdalenost mezi dvojici extremu v sekundach
%         k(4)  % minimalni vzdalenost mezi dvema QRS komplexy v sekundach
%         k(5)  % dlka okna pro vpoet prahu
%         k(6)  % nsobek druhho prahu
%         k(7)  % velikost okraje
%         k(8)  % maximln vzdlenost dvou QRS

if typ == 1
   k = [28 1.803 0.05 0.4 1.91*fvz 1.19 0.45 1.2*fvz];  % 98.9550%
elseif typ == 2
   k = [15.1 1.73 0.112 0.29 2.05*fvz 1.2 0 1.12*fvz];  % 99.6038%
else
   k = [22 1.85 0.112 0.29 2.05*fvz 1.2 0 1.12*fvz];    % 99.0159%
end

pasmo = k(1);
vlnka = 'bior1.5';      % typ vlnky

%------ CWT ---------------------------------------------------------------

band = transformace(vstup_sig,pasmo,vlnka);

%------ VYPOCET PRAHU -----------------------------------------------------

prah = movingstd(band,round(k(5)/2),'central');

%------ DETEKCE QRS -------------------------------------------------------

QRS = polohy_vln(band,k(2)*prah,fvz*k(3)); % funkce nalezne polohy QRS v pasmu

%------ ELIMINACE MULTIVLN ------------------------------------------------

elim = diff(QRS);                   
kde = find(elim < fvz*k(4));
QRS(kde+1) = [];

%------ KOREKCNI PRAVIDLA -------------------------------------------------

again = find(diff(QRS)>k(8));
kraj = round(k(7)*fvz);

new = [];
for i = 1:length(again)
    
    od = QRS(again(i))+kraj;
    do = QRS(again(i)+1)-kraj;
    
    pom = polohy_vln(band(od:do),k(6)*prah(od:do),fvz*k(3));
    new = [new pom+od-1];
    
end

QRS = [QRS new];
QRS = sort(QRS);

elim = diff(QRS);                   
kde = find(elim < fvz*k(4));
QRS(kde+1) = [];

end
function [bod] = polohy_vln(x,prah,mez)
%----- INICIALIZACE -------------------------------------------------------
  
bod = [];
extrem_m = [];
extrem_p = [];
   
%------ NALEZEN PRCHOD NULOU -------------------------------------------

u = find(diff(sign(x)));
u = [1 u length(x)];

%------ NALEZEN EXTREMU --------------------------------------------------

x1 = find(x>=prah);
poz1 =  find(diff(x1)-1);
poz1 = [0 poz1 length(x1)];
if length(poz1) > 2
    for i = 1:length(poz1)-1
        k = x( x1(poz1(i)+1:poz1(i+1)) );
        extrem_p(i) = find(k == max(k)) + x1(poz1(i)+1)-1;
    end
end

x2 = find(x<=-prah);
poz2 =  find(diff(x2)-1);
poz2 = [0 poz2 length(x2)];
if length(poz2) > 2
    for i = 1:length(poz2)-1
        k = x( x2(poz2(i)+1:poz2(i+1)) );
        extrem_m(i) = find(k == min(k)) + x2(poz2(i)+1)-1;
    end
end

%------ NALEZEN PRUCHODU NULOU MEZI EXTREMY ------------------------------

if ~isempty(extrem_p) && ~isempty(extrem_m)
    
for i = 1:length(extrem_p)
    k = find(extrem_m>extrem_p(i),1,'first');
    if ~isempty(k)
        kk = find(extrem_p<extrem_m(k),1,'last');
        if  extrem_p(i)==extrem_p(kk) && extrem_m(k)-extrem_p(i)< mez
            poloha = find(u>=extrem_p(i) & u<=extrem_m(k));
            poloha = u(poloha(ceil(length(poloha)/2)));
        bod = [bod poloha];
        end
    end
end

for i = 1:length(extrem_m)
    k = find(extrem_p>extrem_m(i),1,'first');
    if ~isempty(k)
        kk = find(extrem_m<extrem_p(k),1,'last');
        if  extrem_m(i)==extrem_m(kk) && extrem_p(k)-extrem_m(i)< mez
            poloha = find(u>=extrem_m(i) & u<=extrem_p(k));
            poloha = u(poloha(ceil(length(poloha)/2)));
        bod = [bod poloha];
        end
    end
end

end
%------ SERAZENI POZIC ----------------------------------------------------

bod = sort(bod);

end
function [band] = transformace(vstup_sig,pasmo,vlnka)
%------ NAPOVEDA ----------------------------------------------------------

% funkce provadi rychlou CWT s vyuzitim konvoluce

%------ VYTVORENI FILTRU --------------------------------------------------

if  pasmo == 15 && strcmp(vlnka,'bior1.5')
    imp_char = [-7.60565599708887e-16,-1.85659367047585e-11,-4.45140058022962e-09,8.97251273307321e-08,-6.53831413699163e-07,-3.58815479937255e-06,1.33324726230374e-05,1.72677727375859e-05,-8.13034241591086e-05,-0.000146486039457173,-0.000158209850004651,0.000145613639643926,0.00107927082419663,0.00121693755225996,0.000132862465243511,-0.00200069372513942,-0.00517203607827470,-0.00658411822754586,-0.00590073070315290,-0.00683068849394393,-0.00668885498518011,0.000415044740183573,0.0138419336827928,0.0364237444725993,0.0550911264396067,0.0562097611661096,0.0464790430912854,0.0309942198664056,-0.00410399118501448,-0.0576403173228762,-0.135672219588872,-0.238644260830236,-0.303562256437038,-0.331380919672457,-0.340130389822616,-0.308264798217232,-0.247467189706591,-0.152279038815097,-0.00840605215956051,0.139800722880035,0.239634586842784,0.303380284390641,0.338943983730319,0.332878660953073,0.307990683019033,0.244958260784066,0.148316651348171,0.0643972223407127,0.00884067750687203,-0.0285538987166462,-0.0452044560796249,-0.0554507879029005,-0.0560798652309547,-0.0389972661784107,-0.0156749561683949,-0.00145430879176865,0.00624697761669970,0.00702698923766024,0.00588666001736941,0.00655645951063974,0.00538761083014166,0.00235368499262149,3.87916588733341e-05,-0.00115460182689205,-0.00116549674890849,-0.000213031569019047,0.000152489701845874,0.000145536489723662,9.46800031922444e-05,-1.18267930921447e-05,-1.69189414038318e-05,3.42459175725230e-06,1.09439007460723e-06,-1.76864434296067e-07,1.25969867651953e-08,2.08973938848534e-10];
elseif pasmo == 41 && strcmp(vlnka,'bior1.5')    
    imp_char = [-1.25742756689685e-15,-1.26881392334892e-13,-8.73922309057134e-12,-2.88645843074840e-10,2.97511947557746e-10,5.26727722869422e-09,-3.85925438746758e-08,-4.98158678247319e-08,1.38768100942093e-07,4.17137830605845e-07,-1.05643472903079e-07,-1.38865815307360e-06,-2.13690043263204e-06,-2.09377032496627e-06,-1.97023584679570e-06,2.39748851998860e-06,1.23486742999098e-05,1.94488878778454e-05,1.51784277959329e-05,2.52125057878260e-06,-1.79340650284360e-05,-4.84485880654922e-05,-7.97602833560836e-05,-9.47492497252575e-05,-8.66161406134489e-05,-8.45116725592607e-05,-9.83820978497574e-05,-0.000105001790035676,-4.77225496081356e-05,4.82895244543950e-05,0.000204124685821793,0.000433427530170947,0.000699583234529610,0.000834758415229956,0.000826072378541680,0.000712739837390467,0.000523355623062375,0.000238704928453196,-0.000142000883153561,-0.000582574208477941,-0.00111678631390131,-0.00170671966780629,-0.00255294069225966,-0.00321453155356668,-0.00371366380068779,-0.00402910409422038,-0.00406701277460427,-0.00377511700943481,-0.00356401342128039,-0.00355623518565073,-0.00367967556443057,-0.00398034003646380,-0.00454347381780396,-0.00474231981668435,-0.00411038585644414,-0.00270336142960599,-0.000953120375467694,0.00115742563169297,0.00386087844623606,0.00730828699222139,0.0112316524688249,0.0160393029098479,0.0218181037465998,0.0275732902310478,0.0317314832059487,0.0344470636794224,0.0356636029416735,0.0351534851762619,0.0332361373995689,0.0312156560190402,0.0288557167904198,0.0260202584551251,0.0227187280935774,0.0187504961487219,0.0126907456233335,0.00427873444741241,-0.00573890534619091,-0.0167496344934771,-0.0290146064179105,-0.0438370354098923,-0.0606339181897053,-0.0796755004643571,-0.0969583674084762,-0.124726758030298,-0.146417967009399,-0.164232250289230,-0.178378314311040,-0.189240541420099,-0.195938838583113,-0.200515494199318,-0.203806466540297,-0.205403214959108,-0.204504484593999,-0.201416165839947,-0.195558086652470,-0.186386706649258,-0.173906028449381,-0.159464825486535,-0.143307411178697,-0.123984058705305,-0.100204426861308,-0.0730368340364784,-0.0415330650695232,-0.00537037651685421,0.0319251040679111,0.0646461208167127,0.0929789916496002,0.117701454228338,0.138363090846845,0.155101757772216,0.170043987858716,0.183166383615305,0.193342817648000,0.200095236739690,0.203853723034840,0.205403880218856,0.204460255706795,0.201587133006526,0.197317641128100,0.191524183895262,0.181784529058429,0.168540447735490,0.151769347058811,0.126448539430783,0.108151635804853,0.0854955007483108,0.0656785442975078,0.0483923171104386,0.0328834482711410,0.0200122447567570,0.00871412569850927,-0.00156949938283585,-0.0105801216638661,-0.0172817797255345,-0.0217481857604045,-0.0251200124310823,-0.0281250518503231,-0.0305923260386450,-0.0326849045749701,-0.0346764028796881,-0.0357244909098922,-0.0349314750193850,-0.0326458100138954,-0.0288894088423525,-0.0235464705580775,-0.0175487556090831,-0.0124859514843156,-0.00834430845645248,-0.00476978783852583,-0.00183243434276977,0.000400430378799387,0.00224235561300576,0.00377814994283247,0.00464850489835909,0.00468088476109749,0.00411175320161333,0.00374607536966372,0.00357149738534964,0.00355166657327058,0.00368394086355591,0.00401466535109187,0.00406948640488193,0.00382800248803475,0.00336561452306181,0.00266532787104792,0.00200986318495701,0.00129236369301020,0.000717493087728296,0.000261858890739376,-0.000141753035798926,-0.000452970416298559,-0.000669020848803373,-0.000801000985317976,-0.000847059653789262,-0.000752557340832607,-0.000512580097557159,-0.000259523835261330,-8.50711939328661e-05,2.44545414162085e-05,9.48245104263474e-05,0.000104460291201567,8.64898764976676e-05,8.42755622739342e-05,9.43739310153585e-05,8.59290885945942e-05,5.83333604731448e-05,2.51867213902288e-05,2.53599482507695e-06,-1.25248535268426e-05,-1.91860853303255e-05,-1.54475077203722e-05,-4.54267790716980e-06,1.20319401187173e-06,2.27685253125787e-06,2.07732346221462e-06,1.76458893852726e-06,3.92036692800090e-07,-3.51672021222431e-07,-2.60408465211960e-07,3.64562732130277e-08,4.61779802462585e-08,2.74283112596608e-09,-3.35123314764449e-09,6.55357819646668e-10,-4.61460502880443e-11,-8.09747680208346e-13];
else
    impulz = [zeros(1,round(pasmo*5)) 1 zeros(1,round(pasmo*5))];
    odezva = cwt(impulz,pasmo,vlnka);
    imp_char = odezva(find(odezva));
end
%------ KONVOLUCE ---------------------------------------------------------

zp = (length(imp_char)-1)/2;
zac(1:ceil(zp)) = vstup_sig(1);
kon(1:ceil(zp)) = vstup_sig(end);

vstup_sig = [zac vstup_sig kon];

band = conv(vstup_sig,imp_char);

%------ ELIMINACE ZPOZDENI ------------------------------------------------

band = band(ceil(zp)+1:end-fix(zp));
band = band(ceil(zp)+1:end-ceil(zp));

end
function s = movingstd(x,k,windowmode)
% movingstd: efficient windowed standard deviation of a time series
% usage: s = movingstd(x,k,windowmode)
%
% Movingstd uses filter to compute the standard deviation, using
% the trick of std = sqrt((sum(x.^2) - n*xbar.^2)/(n-1)).
% Beware that this formula can suffer from numerical problems for
% data which is large in magnitude. Your data is automatically
% centered and scaled to alleviate these problems.
%
% At the ends of the series, when filter would generate spurious
% results otherwise, the standard deviations are corrected by
% the use of shorter window lengths.
%
% arguments: (input)
%  x   - vector containing time series data
%
%  k   - size of the moving window to use (see windowmode)
%        All windowmodes adjust the window width near the ends of
%        the series as necessary.
%
%        k must be an integer, at least 1 for a 'central' window,
%        and at least 2 for 'forward' or 'backward'
%
%  windowmode - (OPTIONAL) flag, denotes the type of moving window used
%        DEFAULT: 'central'
%
%        windowmode = 'central' --> use a sliding window centered on
%            each point in the series. The window will have total width
%            of 2*k+1 points, thus k points on each side.
%        
%        windowmode = 'backward' --> use a sliding window that uses the
%            current point and looks back over a total of k points.
%        
%        windowmode = 'forward' --> use a sliding window that uses the
%            current point and looks forward over a total of k points.
%
%        Any simple contraction of the above options is valid, even
%        as short as a single character 'c', 'b', or 'f'. Case is
%        ignored.
%
% arguments: (output)
%  s   - vector containing the windowed standard deviation.
%        length(s) == length(x)

% check for a windowmode
if (nargin<3) || isempty(windowmode)
  % supply the default:
  windowmode = 'central';
elseif ~ischar(windowmode)
  error 'If supplied, windowmode must be a character flag.'
end
% check for a valid shortening.
valid = {'central' 'forward' 'backward'};
ind = find(strncmpi(windowmode,valid,length(windowmode)));
if isempty(ind)
  error 'Windowmode must be a character flag, matching the allowed modes: ''c'', ''b'', or ''f''.'
else
  windowmode = valid{ind};
end

% length of the time series
n = length(x);

% check for valid k
if (nargin<2) || isempty(k) || (rem(k,1)~=0)
  error 'k was not provided or not an integer.'
end
switch windowmode
  case 'central'
    if k<1
      error 'k must be at least 1 for windowmode = ''central''.'
    end
    if n<(2*k+1)
      error 'k is too large for this short of a series and this windowmode.'
    end
  otherwise
    if k<2
      error 'k must be at least 2 for windowmode = ''forward'' or ''backward''.'
    end
    if (n<k)
      error 'k is too large for this short of a series.'
    end
end

% Improve the numerical analysis by subtracting off the series mean
% this has no effect on the standard deviation.
x = x - mean(x);
% scale the data to have unit variance too. will put that
% scale factor back into the result at the end
xstd = std(x);
x = x./xstd;

% we will need the squared elements 
x2 = x.^2;

% split into the three windowmode cases for simplicity
A = 1;
switch windowmode
  case 'central'
    B = ones(1,2*k+1);
    s = sqrt((filter(B,A,x2) - (filter(B,A,x).^2)*(1/(2*k+1)))/(2*k));
    s(k:(n-k)) = s((2*k):end);
  case 'forward'
    B = ones(1,k);
    s = sqrt((filter(B,A,x2) - (filter(B,A,x).^2)*(1/k))/(k-1));
    s(1:(n-k+1)) = s(k:end);
  case 'backward'
    B = ones(1,k);
    s = sqrt((filter(B,A,x2) - (filter(B,A,x).^2)*(1/k))/(k-1));
end

% special case the ends as appropriate
switch windowmode
  case 'central'
    % repairs are needed at both ends
    for i = 1:k
      s(i) = std(x(1:(k+i)));
      s(n-k+i) = std(x((n-2*k+i):n));
    end
  case 'forward'
    % the last k elements must be repaired
    for i = (k-1):-1:1
      s(n-i+1) = std(x((n-i+1):n));
    end
  case 'backward'
    % the first k elements must be repaired
    for i = 1:(k-1)
      s(i) = std(x(1:i));
    end
end

% catch any complex std elements due to numerical precision issues.
% anything that came out with a non-zero imaginary part is
% indistinguishable from zero, so make it so.
s(imag(s) ~= 0) = 0;

% restore the scale factor that was used before to normalize the data
s = s.*xstd;
end

% Lucka
function Q=DET_QRS_FULL_V01(xx,fvz)
% spusteni
% Q=muj_detektor_qrs(xx,fvz) 
% 'xx' je signal
% 'fvz' je vzorkovaci frekvence

[ax,bx]=size(xx);
if bx>ax
    xx=xx';
end

xx=xx(:,1);
% if abs(mean(xx))>0.1
%     
%     [jj1 jj]= find(xx(5:end)>50*abs(mean(xx)));
%     if xx(jj1-1)<1000*mean(xx);
%         xx(jj1)=0;
%     end
% end

rad=round(0.128*fvz);
mez1=25;mez2=31; %testovano m1-test pri a1=0.15
R1=0.001;   %predtim 0.0006
OKNO=round(0.3*fvz);     % 0.25*fvz; %kde hledam maximum
Rk=1.75; % o kolik musi byt interval vetsi nez predchozi aby se zpetne dohledaval QRS
prahZ=4; % prah std pri zpetnem prohledavani
prahh=2; % 2 %prah
mezV=0.13; % mez v puv sig. pri zpetnem proh
NN=0.4;     %cast intervalu  fvz kde nehledam pri zpetnem prohl
% filtrace driftu
s=lynf_HP(xx', fvz);
b=fir1(rad,[mez1/fvz,mez2/fvz]);
% freqz(b,1)
% freqz(b,1)
s=filtfilt(b,1,s);
% phasor transform
PT=atan(s/R1);
PT=atan(s/R1);
PTa=abs(PT);

M=sqrt(R1.^2+s.^2);

QQ=plovouci_max(PTa,OKNO*2);
ss=movingstdL(M, fvz*2);
[fff ff]=find(QQ>0);
qq=M(ff);
sss=ss(ff);
Q=[];
for i=1:length(qq)
    if qq(i)>prahh*sss(i)
        p=round(fvz*0.05);
        if ff(i)-p>1 && ff(i)+p<length(xx)
            [m mm]=max(M(ff(i)-p:ff(i)+p));
            mm=mm+(ff(i)-p);
            Q=[Q mm];
        else
            
            Q=[Q ff(i)];
        end
        
    end
end



%% zpetne hledani , hleda se ted uz jen v signalu M, ne v PT
dd=diff(Q);
oo= [dd 0]>Rk*[0 dd];
oo1=[ 0 oo];
cc=Q((oo==1)); cc=cc(2:end);
cc1=Q((oo1==1));cc1=cc1(2:end);


for g=1:length(cc)
    qn=M(cc(g)+NN*fvz:cc1(g)-NN*fvz);
    [gg gg1]=find(qn>prahZ*std(qn));
    ne=zeros(1, length(qn));
    ne(gg1)=gg1;
    [ rrr rrr1]=max(ne);
    R=cc(g)+NN*fvz+rrr1;
    if M(R)>mezV*M(cc(g)) % kdyz tam fakt nic neni
        Q=[Q R];
    end
end
% figure
% plot(xx)
% hold on
% stem(Q, ones(1, length(Q)))

end
function VYSTUP=plovouci_max(x, okno)
% okno=3;
poc_okno = 0;
    okno2 = floor(okno/2);
    okno2p = okno2+1;
    okno_1 = okno-1;
    poc = 1;
    poz_okno = okno2;
    po_max = okno2;
    WinMax = x(1);
    poc_vystup = 0;
    for poc_okno = 0:1:okno2-1 %% kontroluje, jestli je hodnota vetsi nez prvni, a to v okne okno/2 -1
        if x(poc+1) > WinMax
            WinMax = x(poc+1);
            po_max = okno2p + poc_okno;
        end
        poc=poc+1;
    end
    if po_max == okno2 %% kdyz jsem v pulce okna
        VYSTUP(poc_vystup+1)=WinMax; % jde na vystup dosavadni maximum
    else
        VYSTUP(poc_vystup+1)=0;
    end
    poc_vystup = poc_vystup+1;
    for poc_okno = 0:1:okno2-1
        if x(poc+1)>WinMax
            WinMax=x(poc+1);
            po_max=okno_1;
        else
            po_max=po_max-1;
        end
        if po_max == okno2
            VYSTUP(poc_vystup+1)=WinMax;
        else
            VYSTUP(poc_vystup+1)=0;
        end
        poc = poc+1;
        poc_vystup = poc_vystup+1;
    end
    for poc=poc:1:length(x)-1
        if x(poc+1)>WinMax
            WinMax=x(poc+1);
            po_max=okno_1;
        else
            po_max=po_max-1;
            if po_max < 0
                poc_okno = poc-okno_1;
                WinMax = x(poc_okno+1);
                po_max = 0;
                poz_okno=0;
                for poc_okno = poc_okno:1:poc
                    if x(poc_okno+1)>WinMax
                        WinMax = x(poc_okno+1);
                        po_max = poz_okno;
                    end
                    poz_okno=poz_okno+1;
                end
            end
        end
        if po_max==okno2
            VYSTUP(poc_vystup+1)=WinMax;
        else
            VYSTUP(poc_vystup+1)=0;
        end
        poc_vystup=poc_vystup+1;
    end
    poc_okno = poc_okno-1;
    po_max = po_max-1;
    for poc_okno=1:1:okno2p-1
        if po_max<0
            poc_okno=length(x)-okno+poc_okno;
            WinMax=x(poc_okno+1);
            po_max=0;
            poz_okno=1;
            for poc_okno=poc_okno+1:1:length(x)-1
                if x(poc_okno+1)>WinMax
                    WinMax=x(poc_okno+1);
                    po_max=poz_okno;
                end
                poz_okno=poz_okno+1;
            end
        end
        if po_max==okno2
            VYSTUP(poc_vystup+1)=WinMax;
        else
            VYSTUP(poc_vystup+1)=0;
        end
        poc=poc-1;
        po_max=po_max-1;
        poc_vystup=poc_vystup+1;


    end
end
function out = lynf_HP(in, fvz)

        fmez = 0.67;
   
    K = round(fvz/fmez);
    b = ones(1,K);
    a = K;
    b = conv(b,b);
    a = conv(a,a);

    Hdp = filtfilt(b,a,in);
    out = in - Hdp;

%     H = freqz(b,a,fvz, 'whole' );
%     figure(1);plot(abs(H))
%     figure(2);zplane(b,a)
end
function s = movingstdL(x,k,windowmode)
% movingstd: efficient windowed standard deviation of a time series
% usage: s = movingstd(x,k,windowmode)
%
% Movingstd uses filter to compute the standard deviation, using
% the trick of std = sqrt((sum(x.^2) - n*xbar.^2)/(n-1)).
% Beware that this formula can suffer from numerical problems for
% data which is large in magnitude. Your data is automatically
% centered and scaled to alleviate these problems.
%
% At the ends of the series, when filter would generate spurious
% results otherwise, the standard deviations are corrected by
% the use of shorter window lengths.
%
% arguments: (input)
%  x   - vector containing time series data
%
%  k   - size of the moving window to use (see windowmode)
%        All windowmodes adjust the window width near the ends of
%        the series as necessary.
%
%        k must be an integer, at least 1 for a 'central' window,
%        and at least 2 for 'forward' or 'backward'
%
%  windowmode - (OPTIONAL) flag, denotes the type of moving window used
%        DEFAULT: 'central'
%
%        windowmode = 'central' --> use a sliding window centered on
%            each point in the series. The window will have total width
%            of 2*k+1 points, thus k points on each side.
%        
%        windowmode = 'backward' --> use a sliding window that uses the
%            current point and looks back over a total of k points.
%        
%        windowmode = 'forward' --> use a sliding window that uses the
%            current point and looks forward over a total of k points.
%
%        Any simple contraction of the above options is valid, even
%        as short as a single character 'c', 'b', or 'f'. Case is
%        ignored.
%
% arguments: (output)
%  s   - vector containing the windowed standard deviation.
%        length(s) == length(x)

% check for a windowmode
if (nargin<3) || isempty(windowmode)
  % supply the default:
  windowmode = 'central';
elseif ~ischar(windowmode)
  error 'If supplied, windowmode must be a character flag.'
end
% check for a valid shortening.
valid = {'central' 'forward' 'backward'};
ind = find(strncmpi(windowmode,valid,length(windowmode)));
if isempty(ind)
  error 'Windowmode must be a character flag, matching the allowed modes: ''c'', ''b'', or ''f''.'
else
  windowmode = valid{ind};
end

% length of the time series
n = length(x);

% check for valid k
if (nargin<2) || isempty(k) || (rem(k,1)~=0)
  error 'k was not provided or not an integer.'
end
switch windowmode
  case 'central'
    if k<1
      error 'k must be at least 1 for windowmode = ''central''.'
    end
    if n<(2*k+1)
      error 'k is too large for this short of a series and this windowmode.'
    end
  otherwise
    if k<2
      error 'k must be at least 2 for windowmode = ''forward'' or ''backward''.'
    end
    if (n<k)
      error 'k is too large for this short of a series.'
    end
end

% Improve the numerical analysis by subtracting off the series mean
% this has no effect on the standard deviation.
x = x - mean(x);
% scale the data to have unit variance too. will put that
% scale factor back into the result at the end
xstd = std(x);
x = x./xstd;

% we will need the squared elements 
x2 = x.^2;

% split into the three windowmode cases for simplicity
A = 1;
switch windowmode
  case 'central'
    B = ones(1,2*k+1);
    s = sqrt((filter(B,A,x2) - (filter(B,A,x).^2)*(1/(2*k+1)))/(2*k));
    s(k:(n-k)) = s((2*k):end);
  case 'forward'
    B = ones(1,k);
    s = sqrt((filter(B,A,x2) - (filter(B,A,x).^2)*(1/k))/(k-1));
    s(1:(n-k+1)) = s(k:end);
  case 'backward'
    B = ones(1,k);
    s = sqrt((filter(B,A,x2) - (filter(B,A,x).^2)*(1/k))/(k-1));
end

% special case the ends as appropriate
switch windowmode
  case 'central'
    % repairs are needed at both ends
    for i = 1:k
      s(i) = std(x(1:(k+i)));
      s(n-k+i) = std(x((n-2*k+i):n));
    end
  case 'forward'
    % the last k elements must be repaired
    for i = (k-1):-1:1
      s(n-i+1) = std(x((n-i+1):n));
    end
  case 'backward'
    % the first k elements must be repaired
    for i = 1:(k-1)
      s(i) = std(x(1:i));
    end
end

% catch any complex std elements due to numerical precision issues.
% anything that came out with a non-zero imaginary part is
% indistinguishable from zero, so make it so.
s(imag(s) ~= 0) = 0;

% restore the scale factor that was used before to normalize the data
s = s.*xstd;
end

% Global
function [glo, pom] = group_QRS(loc,tol,dat)

    m = sort(cell2mat(loc));
    pom = [];
    i = 1; p = 1; N = 1e4;
    while i <= length(m)
        b = min([length(m) p*N]);
        pom = [pom seskup(m(i:b),tol)];
        i = b+1;
        p = p+1;
    end
%     pom = seskup(m,tol);
    
    glo = []; I = false(1,length(pom));
    for j = 1:length(pom)
        if length(pom{1,j}) >= dat/2
            poz = median(pom{1,j});
        else
            poz =[];
            I(j) = true;
        end
        glo = [glo poz];
    end
   
    glo = round(glo);
    pom(I) = [];
    
end
function skupinky = seskup(m, tol)
% function SESKUP2 je zalozena na shlukove analyze
% 
%     skupinky = seskup2(QRSm, vzdalenost)
%        QRSm - bunkove pole, co bunka to svod
%             - kazda bunka obsahuje pozice nadetekovanych bodu v danym svodu
%        vzdalenost - minimalni vzdalenost (ve vzorcich), 
%                     pro rozdeleni na samostatne shluky
%        skupinky - bunkove pole, co bunka to bod
%                 - kazda bunka obsahuje blizke detekce ze vsech (nekterych) svodu (i vicenasobne)
%
%

% 2010-04-27, Jan Hrubes

% cas = 0.1; % s (odhad casu mezi vlnama) 
% fvz = 500; % Hz
% vzdalenost = cas * fvz; % pocet vzorku
if length(m)>=2
    Y = pdist(m'); % vypocet vzdalenosti
    Z = linkage(Y); % shlukovani
    T = cluster(Z,'cutoff', tol,'criterion','distance')'; % rozdeleni do shluku
    [uT,oT] = unique(T,'first'); % zjisteni poctu shluku
    [~,pos] = sort(oT); % zjisteni poradi shluku
    skupinky = cell(1,length(uT)); % a nasazeni do bunkoveho pole
    for i = uT
        skupinky{i} = sort(m(T==pos(i)));
    end
else
    skupinky = {m};
end
end

