function [Sig]=swt_features_fisi_huskova(y,fs)
% y je ecg
% vysledne parametry jsou ulozeny v promenne "Sig"

% load val
% y=val;
% fs=300;
t=(1:length(y))./fs;

d=length(y);
T=1; %40 segment
n=round(d/T); % poet vzork v jednom segmentu
S=zeros(n,T); % matice, 40 sloupc 
for j=1:T
    S(:,j)=y((1+n*(j-1):n*(j)));
end

%% elliptical band-pass filter - 0.5-50 Hz

[b,a] = ellip(5,3,50,[0.004 0.4],'bandpass');
% figure;
% freqz(b,a)

dataOut = filter(b,a,y);

% figure;
% plot(dataOut);
% title('EKG signal po pruchodu filtrem');

d2=length(dataOut);
n2=round(d2/T); % poet vzork v jednom segmentu
S2=zeros(n2,T); %% matice, 20 sloupc 
for j=1:T-1
    S2(:,j)=dataOut((1+n2*(j-1)):(n2*(j)));
end

%% STATIONARY WAVELET TRANSFORM - Diskrtn vlnkov transformace, vlna Daubechies

% zero-padding, dliteln 2^level (64)

L=6;
r=rem(length(S),2^L);
l=2^L-r;

for j=1:T
zpd(:,j)=wextend('1','zpd',S(:,j),l,'r');
end

wname='db5';
SWT=cell(T,2); 
for j=1:T
[swa swd]=swt(zpd(:,j),6,wname); 
SWT{j,1}(1:6,1:length(swa))=swa; 
SWT{j,2}(1:6,1:length(swd))=swd;
end

%% FEATURE EXTRACTION

Sig=cell(T,1);

for z=1:T
    
    %Peak-to-average power ratio
    PAPR_C=[];
    for j=1:6
    coarse_coef=SWT{z,1}(j,:); 
    [psdestx,Fxx] = periodogram(coarse_coef,hamming(length(coarse_coef)),length(coarse_coef));
    pr1=(sum(psdestx))/length(psdestx);
    PAPR_C(j)=max(psdestx)/pr1;
    end

    PAPR_D=[];
    for j=1:6
    detail_coef=SWT{z,2}(j,:); 
    [psdestx2,Fxx2] = periodogram(detail_coef,hamming(length(detail_coef)),length(detail_coef));
    pr2=(sum(psdestx2))/length(psdestx2);
    PAPR_D(j)=max(psdestx2)/pr2;
    end
    
    % LOG-ENERGY-ENTROPY
    e_c=[];
    for j=1:6
    x_c=SWT{z,1}(j,:);
    e_c(j)=wentropy(x_c,'log energy');
    end

    e_d=[];
    for j=1:6
    x_d=SWT{z,2}(j,:); 
    e_d(j)=wentropy(x_d,'log energy');
    end
    
 sigma=[PAPR_D;PAPR_C;e_d;e_c];
 Sig{z,1}=sigma;
 sigma=[];
end


%% AF CLASSIFICATION